-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

if cfg.Game.ui>=100000 then
lib.classes["DEMONHUNTER"] = {}
--local t,s,n
lib.classpreload["DEMONHUNTER"] = function()
	lib.InitPower()
	lib.InitCleave()
	--cfg.Cleave.threshold=3
	
	
	lib.AddSpell("Immolation Aura",{258920},"player")
	lib.AddCleaveSpell("Immolation Aura",nil,{258922})
	lib.AddTalent("Sigil of Flame",204596,"debuff","target")
	
	--lib.AddAura("The Hunt",345335,"debuff","target")
	lib.AddAura("Acquired Axe",368656,"buff","player")
	lib.AddTalent("Felblade",{232893})
	lib.AddTalent("The Hunt",{370965})
	lib.AddTalent("Master of the Glaive",{203556})
	lib.AddTalent("Demonic",{213410})
	lib.AddTalent("Sinful Brand",{317009},"target")
end
-- HAVOC SPEC
lib.classes["DEMONHUNTER"][1] = function()
	--lib.SetPower("Fury")
	--lib.AddResourceBar(cfg.Power.max)
	--lib.ChangeResourceBarType(cfg.Power.type)
	--lib.LoadSwingTimer()
	lib.AddTalent("Initiative",388108)
	if lib.Talent("Initiative") then
		lib.AddAura("Initiative",391215,"buff","player")
	end
	lib.AddTalent("Demon Blades",203555)
	lib.AddTalent("Chaotic Transformation",288754)
	lib.AddTalent("First Blood",206416)
	lib.AddTalent("Trail of Ruin",258881)
	lib.AddTalent("Blind Fury",203550)
	lib.AddTalent("Fel Barrage",258925)
	lib.AddTalent("Netherwalk",{196555},"buff","player")
	lib.AddTalent("Essence Break",{258860})
	lib.AddTalent("Insatiable Hunger",{258876})
	lib.AddTalent("Elysian Decree",{390163})
	lib.AddTalent("Momentum",{206476})
	if lib.Talent("Momentum") then
		lib.AddAura("Momentum",208628,"buff","player")
	end
	lib.AddTalent("Unbound Chaos",{347461})
	if lib.Talent("Unbound Chaos") then
		lib.AddAura("Unbound Chaos",347462,"buff","player")
	end
	lib.AddTalent("Fodder to the Flame",{391429})
	if lib.Talent("Fodder to the Flame") then
		lib.AddAura("Fodder to the Flame",391430,"buff","player")
		lib.AddAura("Demon Soul",347765,"buff","player")
	end
	lib.AddTalent("Glaive Tempest",{342817})
	if lib.Talent("Glaive Tempest") then 
		lib.AddCleaveSpell("Glaive Tempest",nil,{342857})
	end
	
	--cfg.talents={
		--["Demon Blades"]=IsPlayerSpell(203555),
		
		--["First Blood"]=IsPlayerSpell(206416),
	
	
		--["Blind Fury"]=IsPlayerSpell(203550),
		--["Demonic Appetite"]=IsPlayerSpell(206478),
		--["Insatiable Hunger"]=IsPlayerSpell(258876),
		
		--["Immolation Aura"]=IsPlayerSpell(258920),
		--["Trail of Ruin"]=IsPlayerSpell(258881),
		--["Fel Mastery"]=IsPlayerSpell(192939),
		--["Fel Barrage"]=IsPlayerSpell(258925),
		--["Soul Rending"]=IsPlayerSpell(204909),
		--["Desperate Instincts"]=IsPlayerSpell(205411),
		--["Netherwalk"]=IsPlayerSpell(196555),
		--["Cycle of Hatred"]=IsPlayerSpell(258887),
		--["First Blood"]=IsPlayerSpell(206416),
		--["Dark Slash"]=IsPlayerSpell(258860),
		--["Unleashed Power"]=IsPlayerSpell(206477),
		--["Master of the Glaive"]=IsPlayerSpell(203556),
		--["Fel Eruption"]=IsPlayerSpell(211881),
		--["Demonic"]=IsPlayerSpell(213410),
		--["Momentum"]=IsPlayerSpell(206476),
		--["Nemesis"]=IsPlayerSpell(206491),
		--["Unbound Chaos"]=IsPlayerSpell(347461),
		--["Glaive Tempest"]=IsPlayerSpell(342817),
		--["Essence Break"]=IsPlayerSpell(258860),
		--["Sinful Brand"]=IsPlayerSpell(300728),
		
	--}
	--if cfg.talents["Essence Break"] then
	--	lib.AddSpell("Essence Break",{258860})
	--end
	--if cfg.talents["Unbound Chaos"] then
	--	lib.AddAura("Unbound Chaos",347462,"buff","player")
	--end
	
	--if cfg.talents["Glaive Tempest"] then
	--	lib.AddSpell("Glaive Tempest",{342817})
	--	lib.AddCleaveSpell("Glaive Tempest",nil,{342857})
	--end
	lib.AddSpell("Blade Dance",{210152,188499},true)
	lib.AddCleaveSpell("Blade Dance",nil,{188499,199552,200685,210152,210153,210155})
	lib.AddSpell("Blur",{198589})
	lib.AddSpell("Chaos Strike",{201427,162794})
	--lib.AddSpell("Dark Slash",{258860})
	lib.AddSpell("Darkness",{196718})
	if not lib.Talent("Demon Blades") then
		lib.AddSpell("Demon's Bite",{162243})
		cfg.DB_cost_max=30
		if lib.Talent("Insatiable Hunger") then cfg.DB_cost_max=cfg.DB_cost_max+10 end
	end
	lib.AddSpell("Eye Beam",{198013},nil,nil,true)
	lib.AddCleaveSpell("Eye Beam",nil,{198030})
	lib.AddAura("Furious Gaze",343312,"buff","player")
	--lib.OnSpellCast("Eye Beam",function()
	--[[lib.SetSpellFunction("Eye Beam","OnCast",function()
		local spell="Eye Beam"
		print(GetTime().." Eye Beam "..lib.GetSpellCD(198013,true))
		print(GetSpellCooldown(198013))
		if cfg.Channeling.name then
			print("Channeling "..cfg.Channeling.endTime-cfg.Channeling.startTime)
		print(cfg.spells[spell].start.." "..cfg.spells[spell].cd.." "..cfg.spells[spell].tl.." "..cfg.spells[spell].fullcd)
		end
		print("---")
		--print(GetTime().." Eye Beam "..{GetSpellCooldown(198013)})
	end)]]
	
	--lib.AddSpell("Fel Barrage",{258925})
	--lib.AddCleaveSpell("Fel Barrage")
	lib.AddSpell("Fel Eruption",{211881},"target")
	lib.AddSpell("Fel Rush",{195072})
	--lib.AddCleaveSpell("Fel Rush")
	
	lib.AddTalent("Metamorphosis",{191427})
	if lib.Talent("Metamorphosis") then 
		lib.AddAura("Metamorphosis",162264,"buff","player")
	end
	lib.SetAuraRefresh("Metamorphosis",30*0.3)
	--lib.AddSpell("Nemesis",{206491},"target")
	lib.AddSpell("Throw Glaive",{185123})
	lib.AddSpell("Vengeful Retreat",{198793})
	lib.AddAura("Blur",212800,"buff","player")
	
--	lib.AddAura("Nemesis2",208579,"buff","player")
--	lib.AddAura("Prepared",203650,"buff","player")

	lib.SetAuraFunction("Metamorphosis","OnApply",function()
		lib.ReloadSpell("Chaos Strike",{201427,162794})
		lib.ReloadSpell("Blade Dance",{210152,188499},true)
		--lib.AddCleaveSpell("Blade Dance",nil, )
		lib.AddTracking("Blade Dance",{255,178,0})
	end)
	lib.SetAuraFunction("Metamorphosis","OnFade",function()
		lib.ReloadSpell("Chaos Strike",{162794,201427})
		lib.ReloadSpell("Blade Dance",{188499,210152},true)
		--lib.AddCleaveSpell("Blade Dance")
		lib.AddTracking("Blade Dance",{255,178,0})
	end)

	lib.SetTrackAura({"Acquired Axe","Unbound Chaos","Momentum"}) --,"Metamorphosis"
	lib.AddTracking("Metamorphosis",{0,0,255})
	lib.AddTracking("Eye Beam",{148,0,211}) --,"Furious Gaze")
	lib.AddTracking("Blade Dance",{255,178,0})

	lib.ResetRotation()
	lib.Rotation("Vengeful Retreat_return")
	lib.Rotation("Kick")
	lib.Rotation("Consume Magic")
	lib.Rotation("Metamorphosis")
	lib.Rotation("Sinful Brand",lib.Talent("Sinful Brand"))
	lib.Rotation("Fel Rush_Unbound Chaos",lib.Talent("Unbound Chaos"))
	lib.Rotation("Eye Beam")
	lib.Rotation("Vengeful Retreat_Initiative",lib.Talent("Initiative"))
	lib.Rotation("Essence Break",lib.Talent("Essence Break"))
	lib.Rotation("Blade Dance")
	lib.Rotation("Fel Rush_Momentum",lib.Talent("Momentum"))
	lib.Rotation("The Hunt",lib.Talent("The Hunt"))	
	lib.Rotation("Elysian Decree",lib.Talent("Elysian Decree"))
	lib.Rotation("Glaive Tempest",lib.Talent("Glaive Tempest"))
	lib.Rotation("Immolation Aura")
	lib.Rotation("Felblade",lib.Talent("Felblade"))
	lib.Rotation("Throw Glaive_Fodder to the Flame",lib.Talent("Fodder to the Flame"))
	lib.Rotation("Chaos Strike",not lib.Talent("Demon Blades"))
	lib.Rotation("Chaos Strike_Demon Blades",lib.Talent("Demon Blades"))
	lib.Rotation("Sigil of Flame",lib.Talent("Sigil of Flame"))
	lib.Rotation("Fel Rush",lib.Talent("Demon Blades"))
	lib.Rotation("Throw Glaive",lib.Talent("Demon Blades"))
	lib.Rotation("Demon's Bite",not lib.Talent("Demon Blades"))
	lib.Rotation("end")

	--cfg.plistaoe = nil
	--cfg.plist=cfg.plistdps

	cfg.case = {
		
		["Metamorphosis"] = function()
			if lib.Talent("Chaotic Transformation") then
				if lib.GetSpellCD("Eye Beam",true)<(lib.GetSpellCD("Metamorphosis")+cfg.gcd) then return nil end
				--if cfg.talents["First Blood"] then
				if lib.GetSpellCD("Blade Dance",true)<(lib.GetSpellCD("Metamorphosis")+cfg.gcd) then return nil end
				if cfg.Power.now<(lib.GetSpellCost("Blade Dance")+lib.GetSpellCost("Eye Beam")) then return nil end
			--else
				--if cfg.Power.now<lib.GetSpellCost("Eye Beam") then return nil end
			end
			return lib.SpellRefreshAura("Metamorphosis")
		end,
		["Fel Rush_Unbound Chaos"] = function ()
			if lib.GetAura({"Unbound Chaos"})>lib.GetSpellCD("Fel Rush") then
				return lib.SimpleCDCheck("Fel Rush",lib.GetAura({"Metamorphosis"}))
			end
			return nil
		end,
		["Throw Glaive_Fodder to the Flame"] = function ()
			if lib.GetAura({"Fodder to the Flame"})>lib.GetSpellCD("Throw Glaive") then
				return lib.SimpleCDCheck("Throw Glaive")
			end
			return nil
		end,
		["Immolation Aura"] = function()
			if (cfg.Power.now<=cfg.Power.max-20) then
				return lib.SimpleCDCheck("Immolation Aura")
			end
			return nil
		end,
		["Vengeful Retreat_Initiative"] = function()
			if (lib.GetSpellCD("Essence Break")-cfg.gcd)<lib.GetSpellCD("Vengeful Retreat")
				or (lib.GetSpellCD("Felblade")-cfg.gcd)<lib.GetSpellCD("Vengeful Retreat")
				or (lib.GetSpellCD("The Hunt")-cfg.gcd)<lib.GetSpellCD("Vengeful Retreat")
			then
				return lib.SimpleCDCheck("Vengeful Retreat",lib.GetAura({"Initiative"}))
			end
		end,
		["Vengeful Retreat_return"] = function ()
			if lib.SpellLastCast("Vengeful Retreat") then
				return lib.SimpleCDCheck(lib.GetSpellShortestCD({"The Hunt","Essence Break","Felblade","Fel Rush"}))
			end
			return nil
		end,
		--[[["Chaos Strike_Demon Blades"] = function ()
			if cfg.Power.now>=math.max(lib.GetSpellCost("Chaos Strike")+lib.GetSpellCost("Eye Beam"),lib.GetSpellCost("Chaos Strike")+lib.GetSpellCost("Blade Dance")) then
				return lib.SimpleCDCheck("Chaos Strike")
			end
			return nil
		end,]]
		
		["Chaos Strike_Demon Blades"] = function ()
			if lib.Talent("Sinful Brand") then
				if lib.GetAura({"Sinful Brand"})>lib.GetSpellCD("Eye Beam")
				and (lib.GetSpellCD("Eye Beam",true)-lib.GetSpellCD("Chaos Strike",true))<=cfg.gcd then
					return nil
				end
			end
			if lib.GetSpellCD("Eye Beam",true)<(lib.GetSpellCD("Chaos Strike",true)+3*cfg.gcd) 
			and cfg.Power.now<(lib.GetSpellCost("Chaos Strike")+lib.GetSpellCost("Eye Beam")) then
				return nil
			end
			if (lib.GetSpellCD("Blade Dance",true)<(lib.GetSpellCD("Chaos Strike",true)+3*cfg.gcd) and 
				cfg.Power.now<(lib.GetSpellCost("Chaos Strike")+lib.GetSpellCost("Blade Dance"))) then
				return nil
			end
			return lib.SimpleCDCheck("Chaos Strike")
		end,
		--[[["Blade Dance"] = function()
			if lib.GetSpellCD("Eye Beam",true)<(lib.GetSpellCD("Blade Dance",true)+cfg.gcd) and 
				cfg.Power.now<(lib.GetSpellCost("Blade Dance")+lib.GetSpellCost("Eye Beam")) then
					return nil
			end
			return lib.SimpleCDCheck("Blade Dance")
		end,]]
		
		
		["Eye Beam_Blind Fury"] = function ()
			if cfg.Power.now>cfg.Power.max-cfg.DB_cost_max or lib.IsChanneling("Eye Beam") then
				return nil
			end
			return lib.SimpleCDCheck("Eye Beam")
		end,
		["Sinful Brand_Eye Beam"] = function ()
			if ((lib.GetSpellCD("Eye Beam")-cfg.gcd)<lib.GetSpellCD("Sinful Brand")) then
				return lib.SimpleCDCheck("Sinful Brand", lib.GetAura({"Sinful Brand"}))
				--return lib.SpellRefreshAura("Sinful Brand")
			end
			return nil
			
		end,
		["Eye Beam_Sinful Brand"] = function ()
			if cfg.talents["Sinful Brand"] then
				if lib.GetAura({"Sinful Brand"})>lib.GetSpellCD("Eye Beam") or lib.GetSpellCD("Sinful Brand")>(lib.GetSpellCD("Eye Beam",true)+15) then
					return lib.SimpleCDCheck("Eye Beam")
				else
					return nil
				end
			else
				return lib.SimpleCDCheck("Eye Beam")
			end
		end,
		
		["Eye Beam_aoe"] = function()
			if (cfg.Cleave.num>=cfg.Cleave.threshold) then
				return lib.SimpleCDCheck("Eye Beam")
			end
			return nil
		end,
		["Glaive Tempest_aoe"] = function()
			if (cfg.Cleave.num>=cfg.Cleave.threshold) then
				return lib.SimpleCDCheck("Glaive Tempest")
			end
			return nil
		end,
		["Demon's Bite"] = function ()
			if cfg.Power.now<=cfg.Power.max-cfg.DB_cost_max then
				return lib.SimpleCDCheck("Demon's Bite")
			end
			return nil
		end,
		
		
		["Blade Dance_aoe"] = function()
			if lib.GetSpellCD("Eye Beam",true)<(lib.GetSpellCD("Blade Dance",true)+3*cfg.gcd) and 
				cfg.Power.now<(lib.GetSpellCost("Blade Dance")+lib.GetSpellCost("Eye Beam")) then
					return nil
			end
			if (cfg.Cleave.num>=cfg.Cleave.threshold) then
				return lib.SimpleCDCheck("Blade Dance")
			end
			return nil
		end,
		
		["Chaos Strike_pre"] = function ()
			if cfg.talents["Sinful Brand"] and lib.GetAura({"Sinful Brand"})>lib.GetSpellCD("Eye Beam") and (lib.GetSpellCD("Eye Beam",true)-lib.GetSpellCD("Chaos Strike",true))<=cfg.gcd then return nil end
			if lib.GetSpellCD("Eye Beam",true)<(lib.GetSpellCD("Chaos Strike",true)+3*cfg.gcd) and 
				cfg.Power.now<(lib.GetSpellCost("Chaos Strike")+lib.GetSpellCost("Eye Beam")) then return nil end
			if cfg.noaoe==false and 
			(cfg.Cleave.num>=cfg.Cleave.threshold or (cfg.Cleave.num>1 and lib.GetAura({"Metamorphosis"})>lib.GetSpellCD("Blade Dance",true))) then
				if (lib.GetSpellCD("Blade Dance",true)<(lib.GetSpellCD("Chaos Strike",true)+3*cfg.gcd) and 
					cfg.Power.now<(lib.GetSpellCost("Chaos Strike")+lib.GetSpellCost("Blade Dance"))) then
					return nil
				end
			end
			if cfg.talents["First Blood"] then
				if (lib.GetSpellCD("Blade Dance",true)<(lib.GetSpellCD("Chaos Strike",true)+3*cfg.gcd) and 
					cfg.Power.now<(lib.GetSpellCost("Chaos Strike")+lib.GetSpellCost("Blade Dance"))) then
					return nil
				end
			end
			return lib.SimpleCDCheck("Chaos Strike")
		end,
		--["Vengeful Retreat"] = function()
			--if lib.GetAura({"Prepared"}) > 0 then return nil end
			-- if lib.GetAura({"Prepared"}) > 0 or lib.GetSpellCharges("Fel Rush") == 0 then return nil end
			--return lib.SimpleCDCheck("Vengeful Retreat")
		--end,
		
		["Fel Rush_max"] = function()
			if lib.GetSpellCD("Fel Rush", false, 1) > lib.GetSpellCD("Vengeful Retreat") then return nil end
			if lib.GetAura({"Prepared"}) == 0 or
			lib.GetSpellCharges("Fel Rush") == 2 or
			(lib.GetSpellCharges("Fel Rush") == 1 and lib.GetSpellCD("Fel Rush", false, 2) < 3) then
				return lib.SimpleCDCheck("Fel Rush")
			end
			return nil
		end,
		["Fel Rush_Momentum"] = function()
			return lib.SimpleCDCheck("Fel Rush",lib.GetAura({"Momentum"}))
		end,
		["Dark Slash"] = function()
			if cfg.Power.now < 80 then return nil end
			return lib.SimpleCDCheck("Dark Slash")
		end,
		
		["Immolation Aura_aoe"] = function()
			if (cfg.Cleave.num>=2) and (cfg.Power.now<=cfg.Power.max-20) then
				return lib.SimpleCDCheck("Immolation Aura")
			end
			return nil
		end,
		
		["Death Sweep_aoe"] = function()
			if lib.GetAura({"Metamorphosis"})<=lib.GetSpellCD("Blade Dance",true) then return nil end
			if cfg.talents["Sinful Brand"] then
				if lib.GetSpellCD("Blade Dance",true)<lib.GetAura({"Sinful Brand"}) and (lib.GetSpellCD("Eye Beam",true)+cfg.gcd)>lib.GetAura({"Sinful Brand"}) then return nil end
				if lib.GetSpellCD("Blade Dance",true)>=lib.GetAura({"Sinful Brand"}) and (lib.GetSpellCD("Eye Beam",true)+cfg.gcd)>lib.GetSpellCD("Sinful Brand") then return nil end
			end
			
			if cfg.Cleave.num>=cfg.Cleave.threshold then
				return lib.SimpleCDCheck("Blade Dance")
			end
			return nil
		end,
		
		["Death Sweep"] = function()
			if (lib.GetAura({"Metamorphosis"})>lib.GetSpellCD("Blade Dance",true)) then
				return lib.SimpleCDCheck("Blade Dance")
			end
			return nil
		end,
		
		--[[["Fel Rush"] = function()
			if lib.GetSpellCD("Fel Rush", false, 1) > lib.GetSpellCD("Vengeful Retreat") then return nil end
			return lib.SimpleCDCheck("Fel Rush")
		end,]]
	}
	lib.AddRangeCheck({
		{"Chaos Strike",nil},
		{"Kick",{0,0,1,1}},
		{"Throw Glaive",{0,1,0,1}},
	})
	return true
end

-- VENGEANCE SPEC
lib.classes["DEMONHUNTER"][2] = function()
	lib.AddTalent("Fracture",{263642})
	lib.AddTalent("Shear Fury",{389997})
	lib.AddTalent("Spirit Bomb",{247454})
	--cfg.MonitorSpells=true
	--lib.SetPower("Pain")
	--lib.AddResourceBar(cfg.Power.max)
	--lib.ChangeResourceBarType(cfg.Power.type)
	--[[cfg.talents={
		["Abyssal Strike"]=IsPlayerSpell(207550),
		["Agonizing Flames"]=IsPlayerSpell(207548),
		["Razor Spikes"]=IsPlayerSpell(209400),
		["Feast of Souls"]=IsPlayerSpell(207697),
		["Fallout"]=IsPlayerSpell(227174),
		["Burning Alive"]=IsPlayerSpell(207739),
		["Flame Crash"]=IsPlayerSpell(227322),
		["Charred Flesh"]=IsPlayerSpell(264002),
		["Soul Rending"]=IsPlayerSpell(217996),
		["Feed the Demon"]=IsPlayerSpell(218612),
		["Fracture"]=IsPlayerSpell(263642),
		["Concentrated Sigils"]=IsPlayerSpell(207666),
		["Quickened Sigils"]=IsPlayerSpell(209281),
		["Sigil of Chains"]=IsPlayerSpell(202138),
		["Gluttony"]=IsPlayerSpell(264004),
		["Spirit Bomb"]=IsPlayerSpell(247454),
		["Fel Devastation"]=IsPlayerSpell(212084),
		["Last Resort"]=IsPlayerSpell(209258),
		["Void Reaver"]=IsPlayerSpell(268175),
		["Soul Barrier"]=IsPlayerSpell(263648),
		["Sinful Brand"]=IsPlayerSpell(300728),
	}]]

	--lib.AddSpell("Consume Magic",{278326})
	lib.AddSpell("Demon Spikes",{203720})
	lib.AddSpell("Fel Devastation",{212084},nil,nil,true)
	lib.AddCleaveSpell("Fel Devastation")
	lib.AddSpell("Fiery Brand",{204021})
	if not lib.Talent("Fracture") then
		lib.AddSpell("Shear",{203782})
		cfg.Shear=10
		if lib.Talent("Shear Fury") then cfg.Shear=Shear+10 end
	end
	
	--lib.AddSpell("Fracture",{263642})
	--lib.AddSpell("Immolation Aura",{178740},true)
	lib.AddSpell("Infernal Strike",{189110})
	--lib.AddSpell("Sigil of Flame",{204596})
	lib.AddSpell("Soul Barrier",{227225},true)
	lib.AddSpell("Soul Cleave",{228477})
	lib.AddCleaveSpell("Soul Cleave") --,nil,{228478}
	if cfg.talents["Spirit Bomb"] then
		lib.AddSpell("Spirit Bomb",{247454})
		lib.AddCleaveSpell("Spirit Bomb",nil,{247455})
		lib.AddAura("Spirit Bomb",224509,"debuff","target")
	end
	lib.AddSpell("Throw Glaive",{204157})
	-- lib.AddCleaveSpell("Soul Cleave",nil,{228478})

	lib.AddAura("Demon Spikes",203819,"buff","player")
	lib.AddAura("Fiery Brand",207744,"debuff","target")
	lib.AddAura("Sigil of Flame",204598,"debuff","target")
	lib.AddAura("Soul Fragments",203981,"buff","player")
	 --Frailty
	
	 
	lib.AddSpell("Metamorphosis",{187827},"player")
	lib.SetTrackAura({"Fiery Brand","Demon Spikes","Metamorphosis","Soul Fragments"})
	lib.AddTracking("Immolation Aura",{255,178,0})
	--lib.SaveSpell(189111) --For Casts

	lib.ResetRotation()
	--lib.Rotation("Vengeful Retreat_return")
	lib.Rotation("Kick")
	lib.Rotation("Consume Magic")
	lib.Rotation("Metamorphosis")
	lib.Rotation("Demon Spikes")
	lib.Rotation("Sinful Brand",lib.Talent("Sinful Brand"))
	lib.Rotation("Infernal Strike")
	lib.Rotation("Immolation Aura")
	lib.Rotation("Fel Devastation")
	lib.Rotation("Fiery Brand")
	lib.Rotation("Spirit Bomb",lib.Talent("Spirit Bomb"))
	lib.Rotation("Soul Cleave")
	lib.Rotation("Felblade",lib.Talent("Felblade"))
	lib.Rotation("Fracture",lib.Talent("Fracture"))
	lib.Rotation("Shear",not lib.Talent("Fracture"))
	lib.Rotation("Sigil of Flame")
	lib.Rotation("Throw Glaive")
	lib.Rotation("end")


	cfg.case = {
		["Fracture"] = function()
			if (cfg.Power.now<=cfg.Power.max-25) then
				return lib.SimpleCDCheck("Fracture")
			end
			return nil
		end,
		["Shear"] = function()
			if (cfg.Power.now<=cfg.Power.max-cfg.Shear) then
				return lib.SimpleCDCheck("Shear")
			end
			return nil
		end,
		--[[["Soul Cleave"] = function()
			if lib.GetSpellLastCast("Fracture")<cfg.gcd then return nil end
			if lib.GetAuraStacks("Soul Fragments")==0 then
				return lib.SimpleCDCheck("Soul Cleave")
			end
			return nil
		end,]]
		["Soul Cleave"] = function ()
			--if lib.GetSpellLastCast("Fracture")<lib.GetSpellLastCast("Spirit Bomb") then return nil end
			if lib.GetSpellCD("Fel Devastation",true)<(lib.GetSpellCD("Soul Cleave",true)+3*cfg.gcd) and 
				cfg.Power.now<(lib.GetSpellCost("Soul Cleave")+lib.GetSpellCost("Fel Devastation")) then
				return nil
			end
			return lib.SimpleCDCheck("Soul Cleave")
		end,
		["Soul Cleave_Spirit Bomb"] = function ()
			if lib.GetSpellLastCast("Fracture")<lib.GetSpellLastCast("Spirit Bomb") then return nil end
			if lib.GetSpellCD("Fel Devastation",true)<(lib.GetSpellCD("Soul Cleave",true)+3*cfg.gcd) and 
				cfg.Power.now<(lib.GetSpellCost("Soul Cleave")+lib.GetSpellCost("Fel Devastation")) then
				return nil
			end
			if lib.GetAuraStacks("Soul Fragments")==0 then
				return lib.SimpleCDCheck("Soul Cleave")
			end
			return nil
		end,
		["Infernal Strike"] = function()
			return lib.SimpleCDCheck("Infernal Strike",lib.GetSpellCD("Infernal Strike",nil,lib.GetSpellMaxCharges("Infernal Strike")))
		end,
		["Spirit Bomb_4"] = function()
			if lib.GetAuraStacks("Soul Fragments")>=4 then --or (lib.GetSpellLastCast("Fracture")<cfg.gcd and lib.GetAuraStacks("Soul Fragments")>=2)
				return lib.SimpleCDCheck("Spirit Bomb")
			end
			return nil
		end,
		
		["Demon Spikes"] = function()
			return lib.SimpleCDCheck("Demon Spikes",lib.GetSpellCD("Demon Spikes",nil,lib.GetSpellMaxCharges("Demon Spikes")))
		end,
		--[[["Immolation Aura"] = function()
			if cfg.talents["Fallout"] and lib.GetAuraStacks("Soul Fragments") >= 4 then return nil end
			if cfg.Power.max - cfg.Power.now < 20 then return nil end
			return lib.SimpleCDCheck("Immolation Aura")
		end,]]
		--[[["Spirit Bomb"] = function()
			if lib.GetAuraStacks("Soul Fragments") == 0 and cfg.Power.max - cfg.Power.now < 20 then return nil end
			return lib.SimpleCDCheck("Spirit Bomb")
		end,
		["Soul Cleave_SB"] = function()
			if lib.GetAuraStacks("Soul Fragments") < 2 and cfg.Power.max - cfg.Power.now > 20 then return nil end
			return lib.SimpleCDCheck("Soul Cleave")
		end,
		["Shear"] = function()
			if cfg.Power.max - cfg.Power.now < 15 then return nil end
			if lib.GetAuraStacks("Soul Fragments") >= 4 then return nil end
			return lib.SimpleCDCheck("Shear")
		end,]]
		--[[["Infernal Strike"] = function()
			if lib.GetSpellCharges("Infernal Strike") <= 1 then return end
			return lib.SimpleCDCheck("Infernal Strike")
		end,]]
	}
	lib.AddRangeCheck({
		{"Shear",nil},
		{"Fracture",nil},
		{"Felblade",{1,1,0,1}},
		{"Kick",{0,0,1,1}},
		{"Throw Glaive",{0,1,0,1}},
	})
	return true
end

lib.classpostload["DEMONHUNTER"] = function()
	lib.SetInterrupt("Kick",{183752})
	lib.AddDispellTarget("Consume Magic",{278326},{"Magic"})
	if lib.Talent("Sinful Brand") then
		--lib.AddSpell("Sinful Brand",{317009},"target")
		--lib.SetDOT("Sinful Brand")
		lib.SetAuraRefresh("Sinful Brand",8*0.3)
		cfg.case["Sinful Brand"] = function ()
			return lib.SimpleCDCheck("Sinful Brand", lib.GetAura({"Sinful Brand"}))
		end
		if  (lib.GetLegendary("Unity") or lib.GetLegendary("Agony Gaze")) then
			cfg.case["Sinful Brand_refresh"] = function ()
				if lib.GetSpellCD("Eye Beam",true)<lib.GetSpellCD("Sinful Brand") then return nil end
				return lib.SpellRefreshAura("Sinful Brand")
			end
		end
	end
	if lib.Talent("Felblade") then
		cfg.case["Felblade"] = function()
			if (cfg.Power.now<=cfg.Power.max-40) then
				return lib.SimpleCDCheck("Felblade")
			end
			return nil
		end
	end
	if lib.GetLegendary("Burning Wound") then
		lib.AddAura("Burning Wound",346278,"debuff","target")
		lib.SetDOT("Burning Wound")
	end
	--lib.AddAura("Sinful Brand",317009,"debuff","target")
	
	cfg.case["The Hunt"] = function ()
		if cfg.Casting.iscasting then return nil end
		return lib.SimpleCDCheck("The Hunt",lib.SpellCastingLeft("The Hunt"))
	end
	
	--lib.AddTracking("The Hunt",{0,0,255})
	lib.AddTracking("Sinful Brand",{255,0,0})
	
	
	--lib.AddTracking("Immolation Aura",{255,255,0})
	lib.CD = function()
		lib.CDadd("Kick")
		lib.CDadd("Consume Magic")
		-- lib.CDadd("Fel Eruption")
		--lib.CDadd("Throw Glaive")
		--lib.CDadd("Blur")
		--lib.CDAddCleave("Spirit Bomb",nil,218677)
		lib.CDadd("Fiery Brand")
		lib.CDadd("Demon Spikes")
		lib.CDadd("Soul Barrier")
		
		lib.CDadd("Metamorphosis")
		--lib.CDadd("Nemesis")
		--lib.CDadd("Eye Beam")
		--lib.CDAddCleave("Blade Dance",nil,200685)
		lib.CDadd("Vengeful Retreat")
		lib.CDadd("Fel Rush")
		-- lib.CDAddCleave("Immolation Aura",nil,187727,178741) -- 187727
		lib.CDadd("Sigil of Flame")
		-- lib.CDAddCleave("Infernal Strike",nil,189112,189111)
		-- lib.CDAddCleave("Fel Devastation")
		lib.CDadd("Infernal Strike")
		lib.CDadd("Fel Devastation")
		--lib.CDadd("Throw Glaive")
		lib.CDadd("Fel Barrage")
		lib.CDadd("The Hunt")
		lib.CDadd("Sinful Brand")
		--lib.CDadd("Immolation Aura")
		
	end
end
end
